//===========================================================================
//  Trubetskoy Alex,  April 2004
//===========================================================================
#define STRICT
#include <windows.h>
#include <stdio.h>
#include <conio.h>
#pragma hdrstop
#include "somesrvc.h"
//---------------------------------------------------------------------------
DWORD dwErrCode;                      // 
SERVICE_STATUS ss;                    //  
SERVICE_STATUS_HANDLE ssHandle;       //  

LPTSTR SomeServiceName = "SomeService";  // 

//---------------------------------------------------------------------------
void main(int argc, char* argv[]) {
   //  
   SERVICE_TABLE_ENTRY DispatcherTable[] =
   { { SomeServiceName,                       // 
       (LPSERVICE_MAIN_FUNCTION)ServiceMain }, //  
     { NULL, NULL }
   };

   // 
   if(!StartServiceCtrlDispatcher(DispatcherTable)) {
      printf("StartServiceCtrlDispatcher: Error %ld\n",
             GetLastError());
      getch();
      return;
   }
}

//---------------------------------------------------------------------------
void WINAPI ServiceMain(DWORD argc, LPSTR* argv) {
   //   
   ssHandle = RegisterServiceCtrlHandler(SomeServiceName, ServiceControl);
   if(!ssHandle) {
      printf("Error registering ServiceControl\n");
      getch();
      return;
   }

   // ,   :
   //    
   ss.dwServiceType = SERVICE_WIN32_OWN_PROCESS;
   //    
   SetSomeServiceStatus(SERVICE_START_PENDING, NO_ERROR, 4000);

   //  SomeService
   InitSomeServiceData();

   //   
   SetSomeServiceStatus(SERVICE_RUNNING, NO_ERROR, 0);

   //  
   //...

   return;
}

//---------------------------------------------------------------------------
void WINAPI ServiceControl(DWORD dwControlCode) {
   //     
   switch(dwControlCode) {
      //  
      case SERVICE_CONTROL_STOP: {
         //   
         SetSomeServiceStatus(SERVICE_STOP_PENDING, NO_ERROR, 0);

         // 
         StopSomeService();

         //   
         SetSomeServiceStatus(SERVICE_STOPPED, NO_ERROR, 0);
         break;
      }
      //   
      case SERVICE_CONTROL_INTERROGATE: {
         SetSomeServiceStatus(ss.dwCurrentState, NO_ERROR, 0);
         break;
      }
      default: {
         SetSomeServiceStatus(ss.dwCurrentState, NO_ERROR, 0);
         break;
      }
   }
}

//---------------------------------------------------------------------------
void SetSomeServiceStatus(DWORD dwCurrentState,
                           DWORD dwWin32ExitCode,
                           DWORD dwWaitHint)
{
   //   
   static DWORD dwCheckPoint = 1;

   //      ,   
   if(dwCurrentState == SERVICE_START_PENDING)
      ss.dwControlsAccepted = 0;
   else
      ss.dwControlsAccepted = SERVICE_ACCEPT_STOP;

   ss.dwCurrentState = dwCurrentState;
   ss.dwWin32ExitCode = dwWin32ExitCode;
   //   
   ss.dwWaitHint = dwWaitHint;

   //      ,   
   //  
   if(dwCurrentState == SERVICE_RUNNING || dwCurrentState == SERVICE_STOPPED)
      ss.dwCheckPoint = 0;
   else
      ss.dwCheckPoint = dwCheckPoint++;

   //   
   SetServiceStatus(ssHandle, &ss);
}

//---------------------------------------------------------------------------
BOOL InitSomeServiceData() {
   //...
   return TRUE;
}

//---------------------------------------------------------------------------
BOOL StopSomeService() {
   //...
   return TRUE;
}
//---------------------------------------------------------------------------
