//===========================================================================
//  Trubetskoy Alex,  April 2004
//===========================================================================
#define STRICT
#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#pragma hdrstop
#include "somesrvcappunit.h"

#define IDB_INSTALL 101
#define IDB_START   102
#define IDB_CONFIG  103
#define IDB_STOP    104
#define IDB_REMOVE  105
#define IDB_EXIT    106
//---------------------------------------------------------------------------
HINSTANCE hInst;
char szClassName[] = "SomeServiceApp";
char szWindowTitle[] = "Service Control";

// 
LPTSTR SomeServiceName = "SomeService";
// 
SERVICE_STATUS ss;

//---------------------------------------------------------------------------
#pragma argsused
int APIENTRY
WinMain(HINSTANCE hInstance,
        HINSTANCE hPrevInstance,
        LPSTR     lpszCmdLine,
        int       nCmdShow)   
{
   MSG  msg;   //     
   HWND hwnd;  //    

   //  
   if(!InitApp(hInstance))
      return FALSE;

   //    
   hwnd = CreateWindow(szClassName, szWindowTitle, WS_OVERLAPPEDWINDOW,
                       140, 80, 250, 400, 0, 0, hInstance, NULL);
   if(!hwnd)
      return FALSE;

   ShowWindow(hwnd, nCmdShow);
   UpdateWindow(hwnd);

   //  
   CreateWindow("button", "Install Service",
                WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, 20, 20, 120, 30,
                hwnd, (HMENU) IDB_INSTALL, hInstance, NULL);
   CreateWindow("button", "Start Service",
                WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, 20, 70, 120, 30,
                hwnd, (HMENU) IDB_START, hInstance, NULL);
   CreateWindow("button", "Get Service Configuration",
                WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, 20, 120, 180, 30,
                hwnd, (HMENU) IDB_CONFIG, hInstance, NULL);
   CreateWindow("button", "Stop Service",
                WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, 20, 170, 120, 30,
                hwnd, (HMENU) IDB_STOP, hInstance, NULL);
   CreateWindow("button", "Remove Service",
                WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, 20, 220, 120, 30,
                hwnd, (HMENU) IDB_REMOVE, hInstance, NULL);
   CreateWindow("button", "Exit",
                WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, 20, 270, 90, 30,
                hwnd, (HMENU) IDB_EXIT, hInstance, NULL);

   //    
   while(GetMessage(&msg, 0, 0, 0)) {
      DispatchMessage(&msg);
   }
   return msg.wParam;
}

//---------------------------------------------------------------------------
BOOL
InitApp(HINSTANCE hInstance)
{
   ATOM aWndClass; //    
   WNDCLASS wc;    //     

   memset(&wc, 0, sizeof(wc));

   wc.style = 0;
   wc.lpfnWndProc = (WNDPROC) WndProc;
   wc.cbClsExtra = 0;
   wc.cbWndExtra = 0;
   wc.hInstance = hInstance;
   wc.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_APPLICATION));
   wc.hCursor = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = (HBRUSH)COLOR_BACKGROUND;
   wc.lpszMenuName = (LPSTR)NULL;
   wc.lpszClassName = (LPSTR)szClassName;

   //  
   aWndClass = RegisterClass(&wc);
   return (aWndClass != 0);
}

//---------------------------------------------------------------------------
LRESULT WINAPI
WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
   switch(msg) {
      HANDLE_MSG(hWnd, WM_COMMAND, WndProcOnCommand);
      HANDLE_MSG(hWnd, WM_DESTROY, WndProcOnDestroy);
      case WM_NOTIFY: {
         MessageBox(hWnd, "Message", "Message", MB_OK);
      }
      default:
         return DefWindowProc(hWnd, msg, wParam, lParam);
   }
}

//---------------------------------------------------------------------------
void
WndProcOnCommand(HWND hWnd, int id, HWND hwndCtl, UINT codeNotify) {
   SC_HANDLE hService;            // 
   SC_HANDLE hSCManager;          // Service Control Manager
   LPQUERY_SERVICE_CONFIG lpBufConfig;
   DWORD dwBytesNeeded;
   char szBufConfig[4096];

   switch(id) {
      //   
      case IDB_INSTALL: {
         // SCM
         hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_CREATE_SERVICE);
         if(!hSCManager) {
            MessageBox(NULL, "Can't open Service Control Manager", "Error",
                       MB_OK | MB_ICONERROR);
            break;
         }
         //  SomeService
         hService = CreateService(hSCManager, SomeServiceName,
                          SomeServiceName, SERVICE_ALL_ACCESS,
                          SERVICE_WIN32_OWN_PROCESS, SERVICE_DEMAND_START,
                          SERVICE_ERROR_NORMAL,
                          "c:\\Services\\SomeSrvc.exe",
                          NULL, NULL, NULL, NULL, NULL);
         if(!hService) {
            MessageBox(NULL, "Can't create service", "Error", MB_OK | MB_ICONERROR);
            CloseServiceHandle(hSCManager);
            break;
         }
         //  
         CloseServiceHandle(hService);
         //  SCM
         CloseServiceHandle(hSCManager);
         break;
      }
      // 
      case IDB_START: {
         hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
         if(!hSCManager) {
            MessageBox(NULL, "Can't open Service Control Manager", "Error",
                       MB_OK | MB_ICONERROR);
            break;
         }
         hService = OpenService(hSCManager, SomeServiceName, SERVICE_START);
         if(!hService) {
            GetSomeSvcError();
            break;
         }
         if(!StartService(hService, 0, NULL))
            MessageBox(NULL, "Can't start service", "Error", MB_OK | MB_ICONERROR);
         CloseServiceHandle(hService);
         CloseServiceHandle(hSCManager);
         break;
      }
      //   
      case IDB_CONFIG: {
         hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
         if(!hSCManager) {
            MessageBox(NULL, "Can't open Service Control Manager", "Error",
                       MB_OK | MB_ICONERROR);
            break;
         }
         hService = OpenService(hSCManager, SomeServiceName,
                          SERVICE_QUERY_CONFIG);
         if(!hService) {
            GetSomeSvcError();
            break;
         }
         lpBufConfig = (LPQUERY_SERVICE_CONFIG)malloc(4096);
         if(lpBufConfig != NULL) {
            //   
            QueryServiceConfig(hService, lpBufConfig, 4096, &dwBytesNeeded);
            //  
            wsprintf(szBufConfig, "Binary path: %s\nStart Name: %s\nDisplay Name: %s",
                     lpBufConfig->lpBinaryPathName, lpBufConfig->lpServiceStartName,
                     lpBufConfig->lpDisplayName);
            MessageBox(NULL, szBufConfig, szWindowTitle,
                       MB_OK | MB_ICONINFORMATION);
            free(lpBufConfig);
         }
         else {
            MessageBox(NULL, "Can't create buffer.\nNot enough memory.",
                       "Error", MB_OK | MB_ICONERROR);
         }
         CloseServiceHandle(hService);
         CloseServiceHandle(hSCManager);
         break;
      }
      // 
      case IDB_STOP: {
         hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
         if(!hSCManager) {
            MessageBox(NULL, "Can't open Service Control Manager", "Error",
                       MB_OK | MB_ICONERROR);
            break;
         }
         hService = OpenService(hSCManager, SomeServiceName, SERVICE_STOP);
         if(!hService) {
            GetSomeSvcError();
            break;
         }
         // 
         if(!ControlService(hService, SERVICE_CONTROL_STOP, &ss))
            MessageBox(NULL, "Can't stop service", "Error", MB_OK | MB_ICONERROR);
         CloseServiceHandle(hService);
         CloseServiceHandle(hSCManager);
         break;
      }
      //   
      case IDB_REMOVE: {
         hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
         if(!hSCManager) {
            MessageBox(NULL, "Can't open Service Control Manager", "Error",
                       MB_OK | MB_ICONERROR);
            break;
         }
         hService = OpenService(hSCManager, SomeServiceName,
                                SERVICE_STOP | DELETE);
         if(!hService) {
            GetSomeSvcError();
            break;
         }
         if(ss.dwCurrentState != SERVICE_STOPPED)
            ControlService(hService, SERVICE_CONTROL_STOP, &ss);
         //   
         DeleteService(hService);
         CloseServiceHandle(hService);
         CloseServiceHandle(hSCManager);
         break;
      }
      //  
      case IDB_EXIT: {
         PostQuitMessage(0);
         return;
      }
      default: break;
   }
   return FORWARD_WM_COMMAND(hWnd, id, hwndCtl, codeNotify, DefWindowProc);
}

//---------------------------------------------------------------------------
void
WndProcOnDestroy(HWND hWnd) {
   PostQuitMessage(0);
}

//---------------------------------------------------------------------------
void GetSomeSvcError() {
   DWORD dwError = GetLastError();
   char errMess[100];
   switch(dwError) {
      case ERROR_ACCESS_DENIED: {
         sprintf(errMess, "The specified service control manager"\
                          "database handle does not have access to"\
                          "the service.");
         break;
      }
      case ERROR_INVALID_HANDLE: {
         sprintf(errMess, "The specified handle is invalid.");
         break;
      }
      case ERROR_INVALID_NAME: {
         sprintf(errMess, "The specified service name is invalid.");
         break;
      }
      case ERROR_SERVICE_DOES_NOT_EXIST: {
         sprintf(errMess, "The specified service does not exist.");
         break;
      }
      default: {
         sprintf(errMess, "Can't open service.\nError number not found.");
      }
   }
   MessageBox(NULL, errMess, "Error", MB_OK | MB_ICONERROR);
   return;
}
//---------------------------------------------------------------------------
